//FreqValueBlk.java:  Holds a frequency value and one or two data values.
//
//  9/23/2005 -- [ET]
//

package com.isti.jplotresp;

/**
 * Class FreqValueBlk holds a frequency value and one or two data values.
 */
public class FreqValueBlk
{
    /** Frequency value. */
  public final double freq;
    /** First data value. */
  public final double value1;
    /** Second data value. */
  public final double value2;
    /** Flag set 'true' if second data value exists. */
  public final boolean value2Flag;

  /**
   * Creates a block holding a frequency value and two data values.
   * @param freq amplitude value.
   * @param value1 first data value.
   * @param value2 second data value.
   */
  public FreqValueBlk(double freq, double value1, double value2)
  {
    this.freq = freq;
    this.value1 = value1;
    this.value2 = value2;
    value2Flag = true;
  }

  /**
   * Creates a block holding a frequency value and one data value.
   * @param freq amplitude value.
   * @param value1 phase value.
   */
  public FreqValueBlk(double freq, double value1)
  {
    this.freq = freq;
    this.value1 = value1;
    this.value2 = 0.0;
    value2Flag = false;
  }

  /**
   * Returns a string representation of the values held by this block.
   * @return A string representation of the values held by this block.
   */
  public String toString()
  {
    return "freq=" + freq + ", value1=" + value1 +
                                 (value2Flag ? (", value2=" + value2) : "");
  }
}
