//PlotRun.java:  Entry point and managing module for 'JPlotResp'.
//
//  5/12/2002 -- [KAF]
//  5/14/2002 -- [ET]  Version 0.10Beta:  Changed name from 'Run' to
//                     'PlotRun' to avoid name collision with
//                     'jevalresp.Run'; merged 'RespFrame' into this
//                     class; moved 'consolePanel' into 'RespEntryPanel'
//                     class; implemented plotting classes.
//  5/15/2002 -- [ET]  Version 0.12Beta:  Fixed bug where error message
//                     needed to be cleared; fixed so text fields don't
//                     resize after layout; added "About" button and
//                     improved about window; made "Help" button launch
//                     browser showing manual doc.
//  5/17/2002 -- [ET]  Version 0.13Beta:  Added 'ViewHTMLPanel' to view
//                     help file; increased frame width to 800.
//  6/8/2002 -- [KF]   Version 0.19Beta:  Increased frame height to 700,
//                     change user home to current directory if it is Windows,
//                     Entry Panel: Re-ordered fields, added Filename/Server
//                     browse buttons,
//                     Make the initial cursor location be in the "Network" field,
//                     If accessing FISSURES server, append "  (from server)",
//                     Change the "Response Type" combo-box tool tip text.
//                     JFreeChartPanel: Fixed the popup menu.
//                     Added: RespFileChooser, RespFileFilter, JFreeChartPanel
//  6/11/2002 -- [KF]  Version 0.23Beta:
//                     RespFileChooser: Clear selection when directory is changed,
//                     Entry Panel: Add parent to showDialog,
//                     RespFileChooser: Move bug fixes into new class:
//                     BugfixFileChooser,
//                     Add an AccessoryPanel to select replace/append selections
//                     (NOTE: use RespFileChooser.accessoryPanelEnabled to
//                     disable),
//                     Updates for JFreeChart 0.9.0,
//                     Decreased frame height to 650,
//                     Added: BugfixFileChooser, RespFileChooserAccessoryPanel
//  6/17/2002 -- [KF]  Version 0.24Beta:
//                     Entry Panel: Put about panel and NoBorderLinkButton into
//                     separate files,
//                     Add launch browser ability for JFreeChart from the about
//                     panel,
//                     Use new class for showing dialogs (RespDialog),
//                     Fix the focus order of the verbose check box,
//                     RespFileChooser: When appending remove path if same as
//                     the previous path,
//                     Added: RespAboutPanel, LaunchBrowserButton,
//                     LaunchBrowserTextArea, RespDialog
//  7/5/2002 -- [KF]   Version 0.25Beta:
//                     Updates for JFreeChart 0.9.2,
//                     Move JFreeChart panel into a separate class,
//                     Add Combine Amp/Phase checkbox and default to separate
//                     Amplitude/Phase plots,
//                     Plot phase using linear virtical axis,
//                     Added: RespChartPanel, RespCombinedXYPlot.
//  7/10/2002 -- [KF]  Version 0.26Beta:
//                     Content window has the initial keyboard focus
//                     (instead of the "Close" button) in the ViewHTMLPanel
//                     help window,
//                     Use "Append" button that approves selection instead of
//                     selection type on the file chooser accesory panel,
//                     Remove the "\.\" inside the pathname when using the
//                     current directory and always use the current directory
//                     instead of the user home.
//                     NOTE: With JDK 1.4 the user home is no longer selected
//                     by setting the directory to null and the "Home" button
//                     has been removed.
//  7/10/2002 -- [ET]  Version 0.27Beta:  Added "Amplitude/Phase2" option to
//                     response-type that outputs a single amplitude/phase
//                     ("AP.") file.
//  7/11/2002 -- [KF]  Version 0.28Beta:
//                     Entry Panel: Added checkbox to enable multiple outputs,
//                     Moved the time fields into new class (RespTimePanel)
//                     with an etched border with title and added new set of
//                     time fields using titles "Begin Time" and "End Time",
//                     after returning from browser-dialog sets the focus on
//                     the associated text field.
//                     Added: RespTimePanel
//  7/12/2002 -- [KF]  Version 0.29Beta:  Decreased the size of the browse-
//                     dialog append button.
//  7/13/2002 -- [KF]  Version 0.30Beta:  Added support for "End Time" values.
//  7/16/2002 -- [KF]  Version 0.31Beta:  Updated for JEvalResp v0.974Beta.
//  7/16/2002 -- [ET]  Version 0.32Beta:  Put in support for plotting values
//                     arbitrarily close to zero in vertical log plots.
//  7/17/2002 -- [ET]  Version 0.33Beta:  Improved "Filenames:"/"Server:"
//                     and time field layouts to better handle resizing;
//                     increase frame width from 800 to 825.
//  7/17/2002 -- [ET]  Version 0.34Beta:  Changed "net.sta.cha.loc" in
//                     "multi-out" tooltip to "net.sta.loc.cha".
//   8/6/2002 -- [ET]  Version 0.35Beta:  Moved "LaunchBrowserButton",
//                     "LaunchBrowserTextArea", "FileUtils", "RespDialog"
//                     (renamed to "SimpleDialog") and "ViewHTMLPanel" to
//                     isti.util' and changed references; ; moved file-
//                     chooser classes to isti.util.gui'; improved
//                     generation of tick labels on logarithmic axes when
//                     range of values is small; added end-time to list of
//                     items displayed for responses; added "Header:"
//                     check-box for output files and improved response
//                     information displayed below plot (same as output-
//                     file header information).
//   8/7/2002 -- [ET]  Version 0.36Beta:  Increased frame size from 825x650
//                     to 850x700; put response information displayed below
//                     plot onto 4 lines instead of 2.
//   8/7/2002 -- [ET]  Version 1.0:  Release version.
//   3/5/2003 -- [KF]  Version 1.01: Updates for JFreeChart 0.9.6;
//                     added Print and Save option for plots; added
//                     "Plot Options" section to entry panel.
//  5/14/2003 -- [ET]  Version 1.1:  Changed "com.jrefinery" to "org.jfree"
//                     for JFreeChart 0.9.8; fixed issue of value(s) being
//                     displayed with trailing ".0000000"; added more
//                     tooltips; implemented updates to JFreeChart
//                     (v0.9.9_dev).
//  5/28/2003 -- [KF]  Version 1.12:  Added persistence of entry-screen
//                     settings; modified to not use IstiFileChooser for
//                     Macintosh.
//  5/29/2003 -- [ET]  Version 1.2:  Modified to go back to defaults when
//                     persistence is disabled.
// 10/23/2003 -- [ET]  Version 1.21:  Modifed so that when a tab is closed
//                     the previously-selected tab is reselected; added
//                     splash screen at startup; using updated JEvalResp
//                     version (1.2) with fix to IIR PZ transformation.
//   4/5/2005 -- [ET]  Version 1.25:  Added work-around for Java 1.4.2 bug
//                     (4711700) that could result in 'NullPointerException'
//                     at startup; modified to check for non-positive
//                     amplitude data on logarithmic plot (and switch to
//                     linear plot if found); added "Use Delay" checkbox to
//                     entry screen (for using estimated delay in phase
//                     calculations); implemented "Show Stages..." plot
//                     options to show graph lines for all stages in a
//                     response; added mouse-over tool-tips support on
//                     plots; ; added "Show Input" checkbox to entry
//                     screen (for sending input RESP text to console).
//  4/22/2005 -- [ET]  Version 1.27:  Evened out layout of combo boxes for
//                     output-units/freq-spacing/output-file-type; modified
//                     to show specific error message if 'JEvalResp.jar'
//                     file not found; fixed issue where "Filenames:" radio
//                     button label became "Filename..." on some systems;
//                     updated to JFreeChart v1.0.0-pre2_cvs_20050422.
//  5/23/2005 -- [ET]  Version 1.5:  Public release version.
//   6/1/2005 -- [ET]  Version 1.51:  Using JEvalResp v1.51 (which is
//                     modified to allow negative values in gain stages).
//  6/29/2005 -- [ET]  Version 1.52:  Using JEvalResp v1.52 (which fixes
//                     bug where response sensitivity frequency was not
//                     properly selected when no "stage 0 gain" blockette
//                     was provided).
//  7/11/2005 -- [ET]  Version 1.53:  Using JEvalResp v1.53 (which is
//                     modified to handle List Blockettes (55) that do not
//                     contain an "index" ("i") column in their data).
// 10/13/2005 -- [ET]  Version 1.54:  Using JEvalResp v1.54 (which is
//                     modified to allow decimation and gain blockettes
//                     in stages containing list blockettes); modified
//                     'CmdLnPlotter' to support ability to use AMP/PHASE
//                     files as input.
// 10/31/2005 -- [ET]  Version 1.55:  Added support for List-blockette
//                     interpolation; using JEvalResp v1.55 (which is
//                     modified to support List-blockette interpoloation).
//  8/24/2006 -- [ET]  Version 1.56:  Using JEvalResp v1.56 (which is
//                     modified to support 'Tesla' units and modified to
//                     make sure that if input units are 'Pascal' or
//                     'Tesla' then output units conversion must be
//                     'Velocity' or 'Default').
//  4/30/2007 -- [ET]  Version 1.565:  Modified to use JFreeChart v1.0.5.
//  6/18/2007 -- [ET]  Version 1.57:  Updated to JFreeChart v1.0.5 (which
//                     supports plot zooming on graphs with logarithmic
//                     axes); using JEvalResp v1.57 (which is modified
//                     to check if any FIR coefficients filter should
//                     be normalized to 1.0 at frequency zero and adjust
//                     the filter values if so).
//  7/16/2009 -- [KF]  Version 1.58:  Modified to support running
//                     JPlotResp from another application.
//   6/1/2010 -- [ET]  Version 1.595:  Added "Unwrap Phase" and "Use Total
//                     Sensit" checkbox items; added "fAmplitude/Phase"
//                     item to "Output-File Type" combo box; fixed so if
//                     only "Start Stage" value given then only single
//                     stage is processed; renamed "Use Delay" checkbox
//                     to "Use Est Delay" and updated description;
//                     modified to show response-sensitivity frequency
//                     and A0 normalization factor from first stage in
//                     text under plot.
//   6/3/2010 -- [ET]  Version 1.596:  Changed "A0" to "NormA0" in text
//                     shown under plot (JEvalResp modification).
//   6/8/2010 -- [ET]  Version 1.597:  Added display of sensitivity-
//                     frequency line (and "Show Freq Line" checkbox).
//   8/6/2010 -- [ET]  Version 1.6:  Updated version number for release.
//  9/19/2011 -- [ET]  Version 1.601:  Modified to use updated IstiSmallLogo
//                     graphic on help-about window; updated installer.
//  1/27/2012 -- [ET]  Version 1.65:  Added support for network access to
//                     web-services servers.
//  1/30/2012 -- [ET]  Version 1.7:  Changed default for 'Server' field to
//                     "irisws.prop"; changed references to "FISSURES" in
//                     mouse-over tooltips to "network"; updated version
//                     number for release.
//   4/3/2012 -- [ET]  Version 1.75:  Added "Multi-server plots" checkbox
//                     item and support for specification of multiple
//                     web-services-server URLs.
// 10/30/2013 -- [ET]  Version 1.76:  Added 'b62_x' field and support for
//                     Polynomial Blockette (62), using JEvapResp v1.76;
//                     increased DEF_FRAME_WIDTH from 850 to 1000;
//                     increased MIN_JAVA_VERSION from 1.4 to 1.5.
//  4/11/2014 -- [ET]  Version 1.77:  Updated web-service URLs in '.prop'
//                     files.
//

package com.isti.jplotresp;

import java.io.File;
import java.io.PrintStream;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.isti.util.IstiThread;
import com.isti.util.UtilFns;
import com.isti.util.logging.IstiLogger;
import com.isti.util.logging.IstiConsoleLogger;
import com.isti.util.gui.SplashWindow;
import com.isti.util.gui.IstiFileChooser;
import com.isti.util.gui.IstiFocusManager;
import com.isti.util.gui.SetupLookAndFeel;
import com.isti.util.gui.TabHistoryListener;
import com.isti.jevalresp.RunExt;

/**
 * Class PlotRun is the entry point and managing module for 'JPlotResp'.
 */
public class PlotRun extends RunExt
{
    /** Displayed program name. */
  public static final String PROGRAM_NAME = "JPlotResp";
    /** Program version string. */
  public static final String VERSION_NUM_STR = "1.77";
    /** Program revision string. */
  public static final String REVISION_STR =
                              PROGRAM_NAME + ", Version " + VERSION_NUM_STR;
    /** Filename for splash screen graphic. */
  public static final String SPLASH_GRAPHIC_FNAME = "res/Splash_screen.gif";
    /** Minimum version of Java required. */
  public static final String MIN_JAVA_VERSION = "1.5";
  public final JFrame programFrameObj;
  protected static SplashWindow splashWindowObj = null;    //splash window
    //main frame size:
  protected static final int DEF_FRAME_WIDTH = 1000, DEF_FRAME_HEIGHT = 700;
    //parent panel for all content:
  protected final JPanel mainContentPanel = new JPanel(new BorderLayout());
    //tabbed panel object:
  protected final JTabbedPane mainTabbedPane = new JTabbedPane();
    //entry panel object:
  protected RespEntryPanel entryPanel;
    //"Quit" button:
  protected final JButton quitButton = new JButton("Quit");
    //File object for the current working directory
  protected static final File currentDirectory =
                            new File(".").getAbsoluteFile().getParentFile();

    //dummy references to get classes included in the jar file:
  private static org.jfree.resources.JCommonResources dummyObj;
  private static org.jfree.chart.resources.JFreeChartResources dummyObj2;
  private static org.jfree.base.BaseBoot dummyObj3;
  private static org.jfree.chart.encoders.KeypointPNGEncoderAdapter dumObj4;

    //name of the configuration file:
  protected static final String CONFIG_FNAME = PROGRAM_NAME + ".xml";
  protected final ConfigManager cfgObj;    //handle for config mgr
  protected final IstiLogger logger;

  /**
   * Default exit frame dispose flag is true to dispose frame on exit.
   */
  public static final boolean defaultExitFrameDisposeFlag = true;

  /**
   * Default allow system exit flag is true to allow system exit.
   */
  public static final boolean defaultAllowSystemExitFlag = true;


    //version of Java in use:
  public static final String javaVersionString;
  static
  {      //fetch and check version of Java in use:
    String jVerStr = System.getProperty("java.version");
    if(jVerStr != null)
    {    //Java version string fetched OK
      if(UtilFns.parseVersionNumbers(jVerStr).length > 0 &&
                UtilFns.compareVersionStrings(jVerStr,MIN_JAVA_VERSION) < 0)
      {  //version string format OK and version is too low; show error msg
        System.err.println("This program requires a newer version of " +
                          "Java (Java \"" + jVerStr + "\" in use, Java \"" +
                                MIN_JAVA_VERSION + "\" or later required)");
      }
    }
    else      //unable to fetch Java version string
      jVerStr = "(Unknown)";      //indicate unable to fetch
    javaVersionString = jVerStr;
  }

  /**
   * Exit frame dispose flag is true to dispose frame on exit, false otherwise.
   */
  private boolean exitFrameDisposeFlag = true;

  /**
   * Allow system exit flag is true to allow system exit, false otherwise.
   */
  private boolean allowSystemExitFlag = true;

  /**
   * Constructs and executes the application.
   */
  public PlotRun()
  {
    this(getDefaultFrame(), getDefaultConfigManager(),
         getDefaultLogger());
  }

  /**
   * Constructs and executes the application.
   * @param programFrameObj the frame.
   * @param cfgObj the config manager.
   * @param logger the logger.
   */
  protected PlotRun(
      final JFrame programFrameObj, final ConfigManager cfgObj,
      final IstiLogger logger)
  {
    this.programFrameObj = programFrameObj;
    this.cfgObj = cfgObj;
    this.logger = logger;

    if (!cfgObj.loadSettings())  //if error loading configuration settings
    {
      logger.warning(
          "Error loading settings from configuration file (\"" +
          CONFIG_FNAME + "\"):  " + cfgObj.getErrorMessage());
    }

    if (!cfgObj.useIstiFileChooserFlagProp.booleanValue())
    {
      logger.info("Using default-Java file chooser, " +
                  "'Append' button will not be available");
    }

    // set file choosers to default to the current directory
    IstiFileChooser.setDefaultDirectory(currentDirectory);

    setupFramePositionAndSize();  //set up the frame position and size
    jbInit();
    setupFrame();
  }

  /**
   * Creates a file chooser object.
   * @param frameWidth the width of the file chooser window frame.
   * @param frameHeight the height of the file chooser window frame.
   * @param appendButtonFlag specifies that an "Append" button will be
   * added to the panel (that will append selections to those chosen
   * previously).
   * @return a file chooser object.
   */
  public JFileChooser createFileChooser(
                   int frameWidth,int frameHeight, boolean appendButtonFlag)
  {
    final JFileChooser fc;
    //if using ISTI file choosers
    if (cfgObj.useIstiFileChooserFlagProp.booleanValue())
    {
      fc = IstiFileChooser.createFileChooser(
                                 frameWidth, frameHeight, appendButtonFlag);
    }
    else  //else use JFileChooser
    {
      fc = new JFileChooser();
      fc.setCurrentDirectory(IstiFileChooser.getDefaultDirectory());
      fc.setApproveButtonText(IstiFileChooser.APPROVE_BUTTON_TEXT);
      fc.setApproveButtonMnemonic(
                             IstiFileChooser.APPROVE_BUTTON_TEXT.charAt(0));

      // increase the preferred size (if given):
      if(frameWidth > 0 && frameHeight > 0)
        fc.setPreferredSize(new Dimension(frameWidth,frameHeight));
    }
    return fc;
  }

  /**
   * Determines if the streams should be setup for the console panel.
   * @return true if the streams should be setup, false otherwise.
   */
  protected boolean isSetupStreams()
  {
    return true;
  }

  /**
   * Process parameters and generate output.
   * @param plotFlag a boolean where true indicates output should be plotted.
   */
  protected void processAndOutput(boolean plotFlag)
  {
    entryPanel.processAndOutput(plotFlag);
  }
  /**
   * Remove the Console Panel from the tabbed pane.
   */
  protected void removeConsolePanel()
  {
    entryPanel.removeConsolePanel();
  }

  /**
   * Close all plots.
   */
  protected void closeAllPlots()
  {
    entryPanel.closeAllPlots();
  }

  /**
   * Select the entry panel on the tabbed pane.
   */
  protected void selectEntryPanel()
  {
    entryPanel.selectEntryPanel();
  }

  /**
   * Get the console output.
   * @return the console output printstream.
   */
  public PrintStream getConsoleOut()
  {
    return entryPanel.getConsoleOut();
  }

  /**
   * Executes the given command at some time in the future.
   * @param command the runnable task
   * @param name the task name
   */
  protected void execute(final Runnable command, final String name)
  {
    new IstiThread(command, name).start();
  }

  /**
   * Saves the configuration.
   */
  public void saveConfig()
  {
    storeFrameSettings();  //store the frame sttings
    if(!cfgObj.saveConfig())  //if error saving the settings
    {
      //show message
      logger.warning(cfgObj.getErrorMessage());
    }
  }

  /**
   * Returns true if the program frame position or size has changed,
   * compared to the position loaded from the configuration file.
   * @return true if the program frame position or size has changed.
   */
  public boolean isFrameChanged()
  {
    try
    {
      int frameXPos,frameYPos;       //get current frame position:
      if((frameXPos=programFrameObj.getX()) < 0)
        frameXPos = 0;          //if negative then set to zero
      if((frameYPos=programFrameObj.getY()) < 0)
        frameYPos = 0;          //if negative then set to zero
      return (frameXPos != cfgObj.programFrameXPosProp.intValue() ||
                      frameYPos != cfgObj.programFrameYPosProp.intValue() ||
                                               programFrameObj.getWidth() !=
                                  cfgObj.programFrameWidthProp.intValue() ||
                                              programFrameObj.getHeight() !=
                                  cfgObj.programFrameHeightProp.intValue());
    }
    catch(Exception ex)
    {    //some kind of error occurred
      return false;
    }
  }

  /**
   * Sets up the frame position and size.
   */
  private final void setupFramePositionAndSize()
  {
    //setup default frame width and height to be values in
    // configuration file (or default if out of range):
    int defFrameWidth,defFrameHeight;
    if((defFrameWidth=cfgObj.programFrameWidthProp.intValue()) < 250 ||
       defFrameWidth > 99999)
    {
      //value out of range; use default
      defFrameWidth = DEF_FRAME_WIDTH;
    }
    if((defFrameHeight=cfgObj.programFrameHeightProp.intValue()) < 250 ||
       defFrameHeight > 99999)
    {
      //value out of range; use default
      defFrameHeight = DEF_FRAME_HEIGHT;
    }
    int origFrameWidth, origFrameHeight,
    origFrameXPos = 0, origFrameYPos = 0;
    Dimension dimObj;
    try
    {              //get size of display screen:
      dimObj = Toolkit.getDefaultToolkit().getScreenSize();
    }
    catch(Exception ex)
    {
      //some kind of error; display error message
      logger.warning("Error retrieving screen size:  " + ex);
      dimObj = new Dimension(800,600);      //use default screen size
    }
    //get frame width and height for application; check values:
    if((origFrameWidth=cfgObj.programFrameWidthProp.intValue()) < 250)
      origFrameWidth = defFrameWidth;       //if too small then use default
    else if(origFrameWidth > dimObj.width)
      origFrameWidth = dimObj.width;        //if too large then use max val
    if((origFrameHeight=cfgObj.programFrameHeightProp.intValue()) < 250)
      origFrameHeight = defFrameHeight;     //if too small then default
    else if(origFrameHeight > dimObj.height)
      origFrameHeight = dimObj.height;      //if too large then use max val

    //get frame X & Y positions for application; check values:
    if((origFrameXPos=cfgObj.programFrameXPosProp.intValue()) < 0 ||
       origFrameXPos >= dimObj.width - 250 ||
       (origFrameYPos=cfgObj.programFrameYPosProp.intValue()) < 0 ||
       origFrameYPos > dimObj.height - 250)
    {
      //value to small or too large; setup centered position
      if((origFrameXPos=(dimObj.width-origFrameWidth)/2) < 0)
        origFrameXPos = 0;        //if too small then fix
      if((origFrameYPos=(dimObj.height-origFrameHeight)/2) < 0)
        origFrameYPos = 0;        //if too small then fix
    }
    //make sure bottom-right corner is not off screen:
    if(origFrameXPos+origFrameWidth >= dimObj.width)
      origFrameWidth = dimObj.width - origFrameXPos - 1;
    if(origFrameYPos+origFrameHeight >= dimObj.height)
      origFrameHeight = dimObj.height - origFrameYPos - 1;
    try
    {
      //setup position and size for program's main frame;
      programFrameObj.setBounds(origFrameXPos,origFrameYPos,origFrameWidth,
                                                           origFrameHeight);
    }
    catch(Exception ex)
    {
      logger.warning("Error setting program window location:  " + ex);
    }
  }

  /**
   * Saves the position and size of the program window frame.
   */
  protected void storeFrameSettings()
  {
    try
    {
      cfgObj.programFrameWidthProp.setValue(programFrameObj.getWidth());
      cfgObj.programFrameHeightProp.setValue(programFrameObj.getHeight());
      int frameXPos,frameYPos;       //get current frame position:
      if((frameXPos=programFrameObj.getX()) < 0)
        frameXPos = 0;          //if negative then set to zero
      if((frameYPos=programFrameObj.getY()) < 0)
        frameYPos = 0;          //if negative then set to zero
      //save current main frame location in properties:
      cfgObj.programFrameXPosProp.setValue(frameXPos);
      cfgObj.programFrameYPosProp.setValue(frameYPos);
    }
    catch(Exception ex)
    {
      //some kind of error occurred; display it
      logger.warning("Error fetching window locations:  " + ex);
    }
  }

  /**
   * Component initialization.
   */
  private final void jbInit()
  {
    //put tabbed pane in main content panel:
    mainContentPanel.add(mainTabbedPane,BorderLayout.CENTER);

    //setup quit button:
    quitButton.addActionListener(new java.awt.event.ActionListener()
        {
          public void actionPerformed(ActionEvent e)
          {
            exitProgram();
          }
        });
    quitButton.setForeground(Color.black);
    quitButton.setText("Quit");
    quitButton.setToolTipText("Exit program");
    //create entry panel:
    entryPanel = new RespEntryPanel(mainTabbedPane,this,quitButton);
    entryPanel.addTabbedPane();        //add entry panel as a tab
                   //add change-listener to effect tab-selection behavior:
    mainTabbedPane.addChangeListener(new TabHistoryListener(mainTabbedPane,
                                                                    false));
  }

  /** Sets up the initial focused component on the entry panel. */
  private void setEntryPanelInitialFocus()
  {
    SwingUtilities.invokeLater(new Runnable()
        {
          //setup focus request to happen later:
          public void run()
          {
            entryPanel.setInitialFocus();
          }
        });
  }

  /**
   * Processes parameters, performs requested operations and generates
   * the output plots.
   * @param plotDisplayOptionPanelObj plot display option panel.
   * @return true if successful, false if a parameter error was detected
   * (in which case the 'getErrorMessage()' and 'getExitStatusValue()'
   *  methods may be used to fetch information about the error.)
   */
  public boolean processAndPlot(
                           PlotDisplayOptionPanel plotDisplayOptionPanelObj)
  {
    try
    {
      if(!checkGenerateFreqArray())    //check/generate frequencies array
        return false;        //if error then return false
              //create call-back object that outputs to plots and
              // send it to the generate method:
      return generateResponseOutputs(new CallbackProcPlot(mainTabbedPane,
                outUnitsConvIdx,frequenciesArray,logSpacingFlag,verboseFlag,
                      startStageNum,stopStageNum,useDelayFlag,showInputFlag,
                       listInterpOutFlag,listInterpInFlag,listInterpTension,
                                  unwrapPhaseFlag,totalSensitFlag,b62XValue,
                                    respTypeIndex,stdioFlag,getConsoleOut(),
                                                plotDisplayOptionPanelObj));
    }
    catch(Exception ex)
    {    //some kind of exception error; set error message
      setErrorMessage("Error generating plot:  " + ex);
      ex.printStackTrace();
      return false;
    }
  }

  /**
   * Set if frame is disposed on exit or not.
   * @param b true to dispose frame on exit, false otherwise.
   */
  protected void setExitProgramFrameDispose(boolean b)
  {
    exitFrameDisposeFlag = b;
  }

  /**
   * Set if system exit is allowed or not.
   * @param b true to allow system exit, false otherwise.
   */
  protected void setAllowSystemExit(boolean b)
  {
    allowSystemExitFlag = b;
  }

  /**
   * Show the splash window.
   */
  protected static void showSplashWindow()
  {
    try       //create and display splash screen:
    {
      splashWindowObj = new SplashWindow("JPlotResp program loading...",
                                                 SPLASH_GRAPHIC_FNAME,true);
      splashWindowObj.pack(true);      //size window to graphic & recenter
      splashWindowObj.showWindow();    //show splash screen window
    }
    catch(Exception ex)
    {         //some kind of exception error; send message to 'stderr'
      System.err.println("Error displaying splash screen:  " + ex);
    }
  }

  /**
   * Create the focus manager.
   * @return the focus manager.
   */
  protected static IstiFocusManager createFocusManager()
  {
    IstiFocusManager fm = new IstiFocusManager();
    fm.addTabKeyCode(KeyEvent.VK_ENTER);  //allow ENTER to traverse
    fm.setTraversalFocusListener(new FocusAdapter()
        {
          /**
           * Invoked when a component gains the keyboard focus.
           * @param e event object.
           */
          public void focusGained(FocusEvent e)
          {
            //if source is a text field
            if (e.getSource() instanceof JTextField)
            {
              //select all the text
              ((JTextField)e.getSource()).selectAll();
            }
          }
        });
    FocusManager.setCurrentManager(fm);  //use this focus manager
    return fm;
  }

  /**
   * Setup the focus manager.
   * @param fm IstiFocusManager
   */
  protected void setupFocusManager(final IstiFocusManager fm)
  {
         //setup entry panel GUI components that should have 'Enter'
         // key converted to 'Tab' key:
    final Component [] compArr;
    if((compArr=entryPanel.getTabKeyCompsArray()) != null &&
                                                         compArr.length > 0)
    {    //valid array of components returned; enter it
      fm.addTabKeyXEnabledCompArray(compArr);
    }
  }

  /**
   * Setup the frame.
   */
  private void setupFrame()
  {
    programFrameObj.setTitle(REVISION_STR);      //set program frame title
    //add main content panel to frame:
    programFrameObj.getContentPane().add(mainContentPanel);
    //exit on window close
    programFrameObj.addWindowListener(new WindowAdapter()
        {
          public void windowClosing(WindowEvent e)
          {
            exitProgram();           //exit application
          }
        });
  }

  /**
   * Dispose the splash window.
   */
  protected static void disposeSplashWindow()
  {
    if(splashWindowObj != null)
    {    //splash window is showing
      splashWindowObj.close();         //clear splash screen
      splashWindowObj = null;          //indicate cleared
    }
  }

  /**
   * Show the frame.
   */
  protected void showFrame()
  {
    programFrameObj.setVisible(true); //make program frame visible

    //set the field to have the initial focus
    // (has to happen after the frame is set visible):
    setEntryPanelInitialFocus();
  }

  /**
   * Get the default frame.
   * @return the default frame.
   */
  public static JFrame getDefaultFrame()
  {
    return new JFrame();
  }

  /**
   * Get the default config manager.
   * @return the default config manager.
   */
  public static ConfigManager getDefaultConfigManager()
  {
    return new ConfigManager(CONFIG_FNAME);
  }

  /**
   * Get the default message logger.
   * @return the default message logger.
   */
  public static IstiLogger getDefaultLogger()
  {
    return new IstiConsoleLogger();
  }

  /**
   * Program entry point.
   * @param args program arguments
   */
  public static void main(String[] args)
  {
    //make the "look & feel" setup be the first thing called:
    setupLookAndFeel();
    runJPlotResp(
      getDefaultFrame(), getDefaultConfigManager(), getDefaultLogger(),
      defaultExitFrameDisposeFlag, defaultExitFrameDisposeFlag);
  }

  /**
   * Run 'JPlotResp'.
   * @param programFrameObj the frame.
   * @param cfgObj the config manager.
   * @param logger the logger.
   * @param allowSystemExitFlag true to allow system exit, false otherwise.
   * @param exitFrameDisposeFlag true to dispose frame on exit, false otherwise.
   */
  public static void runJPlotResp(
      final JFrame programFrameObj, final ConfigManager cfgObj,
      final IstiLogger logger, final boolean allowSystemExitFlag,
      final boolean exitFrameDisposeFlag)
  {
    if (!allowSystemExitFlag)  //if system exit is not allowed
    {
      // create the owner so that it may be disposed
      SplashWindow.createOwnerFlag = true;
    }
    showSplashWindow();
    final IstiFocusManager fm = createFocusManager();
    //create instance
    final PlotRun runObj = new PlotRun(
      programFrameObj, cfgObj, logger);
    runObj.setAllowSystemExit(allowSystemExitFlag);
    runObj.setExitProgramFrameDispose(exitFrameDisposeFlag);
    runObj.setupFocusManager(fm);
    disposeSplashWindow();
    runObj.showFrame();
  }

  /**
   * Perform cleanup operations before program termination.
   */
  protected void exitCleanup()
  {
    entryPanel.exitCleanup();     // do cleanup for panels
  }

  /** Processing to be done when the program terminates */
  protected void exitProgram()
  {
    exitCleanup();
    if (allowSystemExitFlag)
      System.exit(0);               // exit the program
    if (exitFrameDisposeFlag)
      programFrameObj.dispose();
  }

  /**
   * Set the current default look and feel.
   */
  protected static void setupLookAndFeel()
  {
    final String className;
     //set "look & feel" to be that of host system:
     className = UIManager.getSystemLookAndFeelClassName();
//        className = UIManager.getCrossPlatformLookAndFeelClassName();
//        className = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
    setupLookAndFeel(className);
  }

  /**
   * Set the current default look and feel.
   * @param className  a string specifying the name of the class that implements
   *        the look and feel
   */
  protected static void setupLookAndFeel(String className)
  {
    SetupLookAndFeel.setLookAndFeel(className);
  }
}
